-- name: [CS] Femtanyl Token
-- description: Stupid bloody cat,, 

local TEXT_MOD_NAME = "Femtanyl Token"

-- Stops mod from loading if Character Select isn't on
if not _G.charSelectExists then
    djui_popup_create("\\#ffffdc\\\n"..TEXT_MOD_NAME.."\nRequires the Character Select Mod\nto use as a Library!\n\nPlease turn on the Character Select Mod\nand Restart the Room!", 6)
    return 0
end

local E_MODEL_FEMTANYL_TEMPRR = smlua_model_util_get_id("Token_Temprr_geo") -- Located in "actors"

local PALETTE_TEMPRR = {
    [HAIR]   = "0000ff",
    [SKIN]   = "ffffff",
    [CAP]    = "000000",
}

local CT_FEMTANYL = _G.charSelect.character_add("Token", "PUSH UR TEMPRR", "KF / Shell", {r = 255, g = 255, b = 255}, E_MODEL_FEMTANYL_TEMPRR, CT_MARIO, "F")
_G.charSelect.character_add_palette_preset(E_MODEL_FEMTANYL_TEMPRR, PALETTE_TEMPRR)
_G.charSelect.character_add_voice(E_MODEL_FEMTANYL_TEMPRR, {nil})

_G.charSelect.credit_add(TEXT_MOD_NAME, "KFIC", "Models")
_G.charSelect.credit_add(TEXT_MOD_NAME, "Shell_x33", "Textures")
_G.charSelect.credit_add(TEXT_MOD_NAME, "Squishy6094", "Coding")

local particleTextures = {
    get_texture_info("femtanyl-particle-1"),
    get_texture_info("femtanyl-particle-2"),
    get_texture_info("femtanyl-particle-3"),
    get_texture_info("femtanyl-particle-4"),
    get_texture_info("femtanyl-particle-5"),
}

local albumTextures = {
    [1] = get_texture_info("femtanyl-album-pushurtemprr")
}

local particleTimer = {}
for i = 0, MAX_PLAYERS do
    particleTimer[i] = math.random(0, 60)
end
local particleTable = {}

local function mario_update(m)
    if m.marioBodyState.eyeState == MARIO_EYES_DEAD then
        m.marioBodyState.capState = MARIO_HAS_DEFAULT_CAP_OFF
    end

    local index = m.playerIndex
    if particleTimer[index] < 0 then
        table.insert(particleTable, {
            pos = {
                x = m.pos.x + math.random(-30, 30),
                y = m.pos.y + math.random(80, 140),
                z = m.pos.z + math.random(-30, 30),
            },
            vel = {
                x = math.random(-5, 5),
                y = math.random(-5, 5),
                z = math.random(-5, 5),
            },
            scale = math.random(1, 3),
            timer = math.random(90, 180),
            texture = particleTextures[math.random(1, #particleTextures)],
            level = gNetworkPlayers[m.playerIndex].currLevelNum,
            act = gNetworkPlayers[m.playerIndex].currActNum,
            area = gNetworkPlayers[m.playerIndex].currAreaIndex,
        })
        particleTimer[index] = math.random(0, 60)
    else
        particleTimer[index] = particleTimer[index] - 1
    end
end

local function vec3f_raycast(a, b)
    return collision_find_surface_on_ray(a.x + (b.x * 0.01), a.y + (b.y * 0.01), a.z + (b.z * 0.01), b.x - a.x, b.y - a.y, b.z - a.z)
end

local worldscale = 496
local function hud_render()
    if #particleTable < 1 then return end
    local m = gMarioStates[0]
    local np = gNetworkPlayers[0]
    local lakituPos = {
        x = gLakituState.pos.x-m.pos.x*0.01,
        y = gLakituState.pos.y-m.pos.y*0.01,
        z = gLakituState.pos.z-m.pos.z*0.01,
    }
    for i = 1, #particleTable do
        local currParticle = particleTable[i]
        if currParticle ~= nil and currParticle.level == np.currLevelNum and currParticle.act == np.currActNum and currParticle.area == np.currAreaIndex then
            local raycast = vec3f_raycast(lakituPos, currParticle.pos)
            local wallIntheWay = raycast.surface ~= nil
            local out = {x = 0, y = 0, z = 0}
            local outPrev = {x = 0, y = 0, z = 0}
            currParticle.pos.x = currParticle.pos.x + currParticle.vel.x
            currParticle.pos.y = currParticle.pos.y + currParticle.vel.y
            currParticle.pos.z = currParticle.pos.z + currParticle.vel.z
            local prevPos = {
                x = currParticle.pos.x - currParticle.vel.x,
                y = currParticle.pos.y - currParticle.vel.y,
                z = currParticle.pos.z - currParticle.vel.z,
            }
            local scale = currParticle.scale * (worldscale/(vec3f_dist(currParticle.pos, lakituPos)))
            djui_hud_world_pos_to_screen_pos(currParticle.pos, out)
            djui_hud_world_pos_to_screen_pos(prevPos, outPrev)
            local offset = scale*currParticle.texture.width*0.5
            if not wallIntheWay then
                djui_hud_render_texture_interpolated(currParticle.texture, outPrev.x - offset, outPrev.y - offset, scale, scale, out.x - offset, out.y - offset, scale, scale)
            end
            if currParticle.timer > 0 then
                currParticle.timer = currParticle.timer - 1
            else
                currParticle.scale = currParticle.scale - 0.05
            end
            if currParticle.scale <= 0 then
                table.remove(particleTable, i)
            end
        end
    end
end

local MATH_DIVIDE_320 = 1/320
local function render_album_art()
    if _G.charSelect.character_get_current_number() ~= CT_FEMTANYL then return end
    local width = djui_hud_get_screen_width() + 1.4
    local widthScale = math.max(width, 321.4) * MATH_DIVIDE_320
    local texture = albumTextures[_G.charSelect.character_get_current_costume()]
    local scale = (1/texture.width) * 90
    local x = width - ((135 * widthScale * 0.8) * 0.5) - texture.width*scale*0.5
    djui_hud_render_texture(texture, x, 115, scale, scale)
end

hook_event(HOOK_ON_HUD_RENDER_BEHIND, hud_render)
_G.charSelect.character_hook_moveset(CT_FEMTANYL, HOOK_MARIO_UPDATE, mario_update)
_G.charSelect.hook_render_in_menu(render_album_art)